uniform float time;

uniform sampler2D flame;
uniform sampler2D noise;

varying vec2 position;
varying vec2 center;

void main(void)
{   
   float dist = distance(position, center);   
   float level = texture2D(noise, vec2(position * 10.0 + (0.5 * dist - 0.05 * time) * vec2(1.0))).x;
   float flameValue = clamp(0.8 - 300.0 * dist + pow(level, 2.0) * 5.0, 0.0, 0.99);
   if (flameValue < 0.1) discard;
   gl_FragColor = texture2D(flame, vec2(pow(flameValue, 2.0), 0.0)) * gl_FrontMaterial.diffuse;
}