uniform float progress;

varying float intensity;

void main()
{		
	vec3 normal = gl_NormalMatrix * gl_Normal;
	vec3 lightDirection = vec3(gl_LightSource[0].position);	

	intensity = max(dot(normal, lightDirection) / 
			      sqrt(dot(normal, normal) * 
				   dot(lightDirection, lightDirection)), 0.0);

	vec4 vertex = mix(gl_Vertex, vec4(gl_Color.xyz, 1.0), progress);
	gl_TexCoord[0] = gl_MultiTexCoord0;
	
	gl_Position = gl_ModelViewProjectionMatrix * vertex;	
}