uniform sampler2D texture;
uniform sampler2DShadow shadow;

varying vec3 shadowPosition;
varying float intensity, specularIntensity;

const float vshift = -0.005;

void main()
{			   

	float shadowValue = max(shadow2D(shadow, 
		shadowPosition + vec3(0.0, 0.0, vshift)).x, 0.2);	

	float newIntensity = intensity * shadowValue;

	gl_FragColor = gl_FrontMaterial.ambient +
		       texture2D(texture, gl_TexCoord[0].st) * 
		       gl_FrontMaterial.diffuse * newIntensity + 
           	       gl_FrontMaterial.specular * specularIntensity;	

     	 		
}