varying vec3 shadowPosition;
varying float intensity, specularIntensity;

uniform float time;

void main()
{		
	
        vec3 normal = gl_NormalMatrix * gl_Normal;	
	vec3 lightDirection = vec3(gl_LightSource[0].position);

	intensity = max(dot(normal, lightDirection) / 
			      sqrt(dot(normal, normal) * 
				   dot(lightDirection, lightDirection)), 0.0);

	
	if (intensity > 0.0)
	{
		vec3 halfVector = vec3(gl_LightSource[0].halfVector);
		float specular = max(dot(halfVector, normal) /
	        		     sqrt(dot(halfVector, halfVector) * 
			           dot(normal, normal)), 0.0);	
		specularIntensity = pow(specular, gl_FrontMaterial.shininess);
	}

	gl_TexCoord[0] = gl_MultiTexCoord0;
	vec4 shadow = gl_TextureMatrix[1] * gl_Vertex;
	shadowPosition = vec3(shadow / shadow.w);
	
	gl_Position = ftransform();	
}